
COLUMNS={'A':'USERID','B':'OPID','C':'COMPANY','D':'FIRMAID','E':'FIRST','F':'LAST'}
USERCELLS=['A','B','C','D','E','F']
GROUPS={'G':'01','H':'02','I':'03','J':'04','K':'05','L':'06','M':'07','N':'08','O':'09','P':'10','Q':'11','R':'12','S':'13','T':'15','U':'17','V':'18','W':'19','X':'20','Y':'21','Z':'25','AA':'26','AB':'63'}
VALIDTRANGROUPS=['A']
USERLDIF='users.ldif'
GROUPLDIF='groups.ldif'
TRANSLDIF='trans.ldif'

OU='people'
GROUPOU='groups'
DC='vitec,dc=org'
EXCELFILE='racf.xlsx'
USERSHEET='Sheet1'
TRANSHEET='Transactions'


from openpyxl import load_workbook
from openpyxl.styles.colors import Color
wb=load_workbook(filename=EXCELFILE,read_only=False)
ws = wb[USERSHEET]
class LDIFUSER():
    userid = ""
    opid = ""
    company = ""
    group = ""
    first = ""
    last = ""
    firmaid = ""
    groups=[]

    def userToString(self):
        try:
            self.userid=self.userid.decode('iso-8859-1')
        except:
            self.userid=self.userid
        string = ""
        string+= "dn: uid=" + self.userid +",ou="+OU+",dc="+DC+'\n'
        string+= "objectClass: top\n"
        string+= "objectClass: person\n"
        string+= "objectClass: organizationalPerson\n"
        string+= "objectClass: inetOrgPerson\n"
        try:
            string+= "uid: " + self.userid.decode('iso-8859-1') + "\n"
        except:
            string+= "uid: " + self.userid + "\n"
        string+= "sn: " + self.first + "\n"
        string+= "cn: " + self.last + "\n"
        string+= "o: " + str(self.opid).encode('utf-8') + "\n"
        string+= "mail: " + self.company + "\n"
        #string+= "firmaid: " + self.firmaid + "\n"
        string+= "userPassword: " + self.userid + "\n"
        string+='\n\n'
        return string

    def usergroupToString(self):
        try:
            self.userid=self.userid.decode('iso-8859-1')
        except:
            self.userid=self.userid
        string = ""
        string+="uniqueMember: uid=" + self.userid +",ou=" + OU+",dc="+DC+'\n'
        return string
    
    def uniqueGroupToString(self):
        string = ""
        string+="uniqueMember: cn=" + self.group.strip() +",ou=" + GROUPOU+",dc="+DC+'\n'
        return string

    def groupToString(self):
        string = ""
        string+= "dn: cn=" + self.group.strip() +",ou="+GROUPOU+",dc="+DC+'\n'
        string+= "objectClass: top\n"
        string+= "objectClass: groupOfUniqueNames\n"
        string+= "cn: " + self.group.strip() + "\n"
        string+="description: " + self.group + " Group\n"
        return string

class TRANGROUP():
    name=""
    trans=[]
    groups=[]

    def tranToString(self):
        string = ""
        string+= "dn: cn=" + self.name.strip() +",ou="+'transactions' +",dc="+DC+'\n'
        string+="description: Transaction " + self.name.strip() + " with groups that have access to it\n"
        string+= "objectClass: top\n"
        string+= "objectClass: groupOfUniqueNames\n"
        string+= "businessCategory: deny:all\n"
        string+= "cn: " + self.name.strip() + "\n"
        return string

    def groupsToString(self):
        string = "# Groups that have access to this trasaction\n"
	count=0
        for t in self.groups:
            string+="uniqueMember: cn=" + str(t).lower() + ",ou=groups,dc=" + DC +',businessCategory=allow:execute\n'
	    count=count+1
	if count == 0:
            string+="uniqueMember: cn=ALLUSERS,ou=groups,dc=" + DC +',businessCategory=deny:all\n'
        return string
    def __repr__(self):
        return self.name +":" + str(self.groups)
        
        

LDIFUSERS=[]

for row in ws.rows:
    ld = LDIFUSER()
    ld.groups=[]
    dontinclude=False
    if 1 == 1:
    #if row[1].value == "918" or row[1].value == "956" or row[1].value == "855":
        for cell in row:
            # if it's marked yellow, let it mellow
            #if cell.value != None:
                        #if cell.style.fill.fgColor.rgb != "00000000":
                            #dontinclude=True
                            #pass
            # avoid first 'title' record
            try:
                if str(cell.column) in USERCELLS:
                    if cell.value != COLUMNS[str(cell.column)]:
                        if COLUMNS[str(cell.column)] == 'USERID':
                            ld.userid = cell.value
                        elif COLUMNS[str(cell.column)] == 'OPID':
                            ld.opid = cell.value
                        elif COLUMNS[str(cell.column)] == 'FIRST':
                            ld.first = cell.value
                        elif COLUMNS[str(cell.column)] == 'LAST':
                            ld.last = cell.value
                        elif COLUMNS[str(cell.column)] == 'COMPANY':
                            ld.company = cell.value
                        elif COLUMNS[str(cell.column)] == 'FIRMAID':
                            ld.firmaid = cell.value
                else:
                    try:
                        if GROUPS[str(cell.column)] !=None:
                            if cell.value == True:
				print 'add ' + GROUPS[str(cell.column)] + " to user " + ld.userid
                                ld.groups.insert(0,GROUPS[str(cell.column)])
                    except Exception as ex:
                        #print "user ex:" + str(ex)
                        pass
            except Exception as ex:
                print "Exception:" + str(ex)
                pass
        if ld.userid != '' and dontinclude == False:
            LDIFUSERS.insert(0,ld)
        #break

#Generate unique user records
target = open(USERLDIF,'w')
doneusers=[]



for l in LDIFUSERS:
    if l.userid not in doneusers:
        target.write(l.userToString().encode('utf-8'))
        doneusers.insert(0,l.userid)
target.close()

#Generate Unique group records
GROUPTRANS={}
target = open(GROUPLDIF,'w')
# create global ALLUSERS group
allgroups_string="""
# Define the overall "ALLUSERS" group that allows server to check if a user has any permission at all
dn: cn=ALLUSERS,ou=groups,dc="""
allgroups_string +=DC
allgroups_string+="""
objectClass: top
objectClass: groupOfUniqueNames
cn: ALLUSERS
description: All Users allowed on the system
"""
# after,  add our groups to this list so the allusers is a group of our user groups

donegroups=[]
donetransgroups=[]
for l in LDIFUSERS:
    #print l.groups
    for g in l.groups:
        l.group=g
        if l.group not in donegroups:
            target.write(l.groupToString())
            allgroups_string+=l.uniqueGroupToString()
	    doneusers=[]
            for gl in LDIFUSERS:
                if l.group in gl.groups and gl.userid not in doneusers:
                    target.write(gl.usergroupToString().encode('utf-8'))
		    doneusers.insert(0,gl.userid)
                    if l.group not in donetransgroups:
                        #GROUPTRANS[l.group]=gl.trans
                        donetransgroups.insert(0,l.group)
            target.write('\n\n')
            donegroups.insert(0,l.group)


# add global ALLUSERS group
target.write(allgroups_string)
target.close()


TRANS=[]
tgs = wb[TRANSHEET]
rows=0
GROUPS=[]
FOUNDTRANS=[]
for row in tgs.rows:
    if rows > 0:
        val=""
        for c in row:
            if c.column == 'A':
                val = str(c.value).split("=")[0].strip()
                if val not in FOUNDTRANS:
                    TG = TRANGROUP();
                    TG.name=val
                    TG.groups=[]
                    TRANS.insert(0,TG)
                    FOUNDTRANS.insert(0,val)
            if c.column == 'C':
                if c.value != val and c.value !=None:
                    for t in TRANS:
                        if t.name==val:
                            t.groups.insert(0,str(c.value).strip())
    rows=rows+1

#Generate transaction group records
target = open(TRANSLDIF,'w')
string=""
string+="""
# Define the overall "programs" resource access control category
# referenced in EBP configuration rac.resourcetypes
dn: ou=programs,dc="""
string+=DC
string+="""
objectClass: organizationalUnit
objectClass: top
ou: programs
"""

string+="""
# By default, anyone can execute most programs in ETP
# Note:  because groupOfUniqueNames must have at least one uniqueMember,
#        it specifies the same permissions as the base object
dn: cn=*,ou=programs,dc="""
string+=DC
string+="""
objectClass: groupOfUniqueNames
objectClass: top
businessCategory: allow:execute
cn: *
description: Default programs executable by anyone
uniqueMember: cn=ALLUSERS,ou="""
string+=GROUPOU
string+=""",dc="""
string+=DC
string+=""",businessCategory=allow:execute
"""

string+="""
# Define the overall "transactions" resource access control category
# referenced in EBP configuration rac.resourcetypes
dn: ou=transactions,dc="""
string+=DC
string+="""
objectClass: organizationalUnit
objectClass: top
ou: transactions
"""
string+="""
# By default, nobody can execute transactions
# Note:  because groupOfUniqueNames must have at least one uniqueMember,
#        it specifies the same permissions as the base object
dn: cn=*,ou=transactions,dc="""
string+=DC
string+="""
objectClass: groupOfUniqueNames
objectClass: top
businessCategory: deny:all
cn: *
description: Default transaction
uniqueMember: cn=ALLUSERS,ou="""
string+=GROUPOU
string+=""",dc="""
string+=DC
string+=""",businessCategory=deny:all
"""



target.write(string)
target.write("\n\n")

for t in TRANS:
    if t.name != None and t.name != "None":
        target.write( t.tranToString())
        target.write( t.groupsToString())
        target.write("\n\n")
    


target.close()

#ldapadd -x -D "cn=Manager,dc=my-domain,dc=com" -W -f users.ldif
